/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.TCoreSpyRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreSpy extends TableImpl<TCoreSpyRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_spy</code>
     */
    public static final TCoreSpy T_CORE_SPY = new TCoreSpy();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreSpyRecord> getRecordType() {
        return TCoreSpyRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_spy.lastchange</code>.
     */
    public final TableField<TCoreSpyRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_spy.operation</code>.
     */
    public final TableField<TCoreSpyRecord, String> OPERATION = createField(DSL.name("operation"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_core_spy.schemaname</code>.
     */
    public final TableField<TCoreSpyRecord, String> SCHEMANAME = createField(DSL.name("schemaname"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_core_spy.tablename</code>.
     */
    public final TableField<TCoreSpyRecord, String> TABLENAME = createField(DSL.name("tablename"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_core_spy.username</code>.
     */
    public final TableField<TCoreSpyRecord, String> USERNAME = createField(DSL.name("username"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_core_spy.remoteip</code>.
     */
    public final TableField<TCoreSpyRecord, String> REMOTEIP = createField(DSL.name("remoteip"), SQLDataType.CLOB, this, "");

    private TCoreSpy(Name alias, Table<TCoreSpyRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreSpy(Name alias, Table<TCoreSpyRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_spy</code> table reference
     */
    public TCoreSpy(String alias) {
        this(DSL.name(alias), T_CORE_SPY);
    }

    /**
     * Create an aliased <code>common_dd.t_core_spy</code> table reference
     */
    public TCoreSpy(Name alias) {
        this(alias, T_CORE_SPY);
    }

    /**
     * Create a <code>common_dd.t_core_spy</code> table reference
     */
    public TCoreSpy() {
        this(DSL.name("t_core_spy"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public TCoreSpy as(String alias) {
        return new TCoreSpy(DSL.name(alias), this);
    }

    @Override
    public TCoreSpy as(Name alias) {
        return new TCoreSpy(alias, this);
    }

    @Override
    public TCoreSpy as(Table<?> alias) {
        return new TCoreSpy(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreSpy rename(String name) {
        return new TCoreSpy(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreSpy rename(Name name) {
        return new TCoreSpy(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreSpy rename(Table<?> name) {
        return new TCoreSpy(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreSpy where(Condition condition) {
        return new TCoreSpy(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreSpy where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreSpy where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreSpy where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreSpy where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreSpy where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreSpy where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreSpy where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreSpy whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreSpy whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
